hdu1969(二分法)

http://acm.hdu.edu.cn/showproblem.php?pid=1969

Pie

Time Limit: 5000/1000 MS (Java/Others) Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 1607 Accepted Submission(s): 559


Problem Description
My birthday is coming up and traditionally I'm serving pie. Not just one pie, no, I have a number N of them, of various tastes and of various sizes. F of my friends are coming to my party and each of them gets a piece of pie. This should be one piece of one pie, not several small pieces since that looks messy. This piece can be one whole pie though.

My friends are very annoying and if one of them gets a bigger piece than the others, they start complaining. Therefore all of them should get equally sized (but not necessarily equally shaped) pieces, even if this leads to some pie getting spoiled (which is better than spoiling the party). Of course, I want a piece of pie for myself too, and that piece should also be of the same size.

What is the largest possible piece size all of us can get? All the pies are cylindrical in shape and they all have the same height 1, but the radii of the pies can be different.


 

Input
One line with a positive integer: the number of test cases. Then for each test case:
---One line with two integers N and F with 1 <= N, F <= 10 000: the number of pies and the number of friends.
---One line with N integers ri with 1 <= ri <= 10 000: the radii of the pies.


 

Output
For each test case, output one line with the largest possible volume V such that me and my friends can all get a pie piece of size V. The answer should be given as a floating point number with an absolute error of at most 10^(-3).


 

Sample Input
3 3 3 4 3 3 1 24 5 10 5 1 4 2 3 4 5 6 5 4 2


 

Sample Output
25.1327 3.1416 50.2655


 

Source


 

Recommend
wangye
题意(来自网上):
意是:分馅饼,注意,每人(包括自己)有且只有一块,即每人的饼不能是由几块组合而成。。。。。求最大的体积,因为高是1,其实就是求做大的面积。。。
设最大的面积为x(即每人拿到的)。。。。转化成方程:a[1]/x + a[2]/x + ..... + a[n]/x = y + 1
其中a[i]/x指各块馅饼最多能分给几个人。。。。由于n是变化的。。。。。所以不能直接像方程那样做。。。。。
而写出一个函数。。。。。。。。。。。注意代码中的函数中的if (count >= y + 1),为什么不是count == y + 1呢?
因为不一定能等于y+1(除非特例),而我们求的解也只是近似解而已。。。。。。。而我们希望他接近y + 1,所以后面成立的时候
l = mid 。。。。。。即x升,y+1降。。。。。。
还有一点就是EPS不能太小。。。。不然超时。。。。。他保留4位,我们就计算到6(4+2)位就可以了。。。。
别忘了计算面积。。。。
 
题目大意是要办生日Party,有n个馅饼,有f个朋友,接下来是n个馅饼的半径。然后是分馅饼了,
注意咯自己也要,大家都要一样大,形状没什么要求,但都要是一整块的那种,也就是说不能从两个饼中
各割一小块来凑一块,像面积为10的和6的两块饼(饼的厚度是1,所以面积和体积相等),
如果每人分到面积为5,则10分两块,6切成5,够分3个人,如果每人6,则只能分两个了!
题目要求我们分到的饼尽可能的大!

只要注意精度问题就可以了,一般WA 都是精度问题
运用2分搜索:
首先用总饼的体积除以总人数,得到每个人最大可以得到的V,但是每个人手中不能有两片或多片拼成的一块饼,
最多只能有一片分割过得饼。用2分搜索时,把0设为left,把V 设为right。mid=(left+right)/2;
搜索条件是:以mid为标志,如果每块饼都可以分割出一个mid,那么返回true,说明每个人可以得到的饼的体积可以
大于等于mid;如果不能分出这么多的mid,那么返回false,说明每个人可以得到饼的体积小于等于mid。
(1)精度为:0.000001
(2)   pi 用反余弦求出,精度更高。
 
#include 
#include
#include
#include
using namespace std;
#define maxn 10010
#define pi acos(-1.0)//求PI
double size[maxn];
int n,f;
bool judge(double mid)
{
    int  p=0;
    for(int i=1;i<=n;i++)
    {
        p+=(int)(size[i]/mid);//不加(int)直接wa而且(int)的范围是整个式子
    }
    if(p>=f+1)
            return true;
    else
        return false;
}
int main()
{
    int t;
    scanf("%d",&t);
    while(t--)
    {
        scanf("%d%d",&n,&f);
        double sum=0.0;
        memset(size,0,sizeof(size));
        for(int i=1;i<=n;i++)
        {
            scanf("%lf",&size[i]);
            size[i]=size[i]*size[i]*pi;
            sum+=size[i];
        }
        double mid,low,high;
        high=(double)sum/(f+1);
        low=0;
        mid=0;
        while(high-low>1e-7)//二分法
        {
            mid=(double)(high+low)/2;
            if(judge(mid))
            {
                low=mid;
            }
            else
            {
                high=mid;
            }
        }
        printf("%.4lf\n",mid);
    }
    return 0;
}
  • 0
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值